from dataclasses import dataclass

from src.core.api_request import account_post
from src.core.constant import BANNER_URL
from src.entity.account import Account


@dataclass
class BannerInfo:
    registerMembers: int
    firstDepositNum: int
    netWinLose: float
    totalMembers: int
    activeMembers: int
    commissionLevel: float
    depositIncrease: float
    effectiveNew: int
    profit: float
    registerIncrease: float
    agentCode: str

    def __init__(self, **kwargs):
        for key, value in kwargs.items():
            if value is not None:
                setattr(self, key, value)


def get_banner_info(account: Account) -> BannerInfo:
    api_response = account_post(url=BANNER_URL, account=account, params={})
    banner_info = BannerInfo(**api_response.data)
    banner_info.agentCode = account.username
    return banner_info
